%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% TP 3 de Data Mining : k moyennes et EM
% Auteur : Maxime Chambreuil - Florian Boitrel
% Date : 12 mars 2003

close all
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialisation des variables

mClasse = randn(5,2);
mClasse1 = [];
mClasse2 = [];
mClasse3 = [];
mClasse4 = [];
mClasse5 = [];
nbIndividu = 10;
nbVar = 2;
matVarCov = eye(2);
nbIteration = 20;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Génération de l echantillon

%%%%%%%%%% 
% Classe 1
esperance = [0 3];
echantillon = genererMatNormale(nbIndividu,nbVar,esperance,matVarCov);

%%%%%%%%%% 
% Classe 2
esperance = [0 -3];
echantillon = [ echantillon ; genererMatNormale(nbIndividu,nbVar,esperance,matVarCov)];

%%%%%%%%%% 
% Classe 3
esperance = [3 1];
echantillon = [ echantillon ; genererMatNormale(nbIndividu,nbVar,esperance,matVarCov)];

n = length(echantillon);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Affichage initial de l echantillon

plot(echantillon(:,1),echantillon(:,2),'+');

%%%%%%%%%%%%%%%%%%%%%%%
% Recherche des classes

for j=1:nbIteration

     % Calcul de la matrice distance
     for i=1:length(mClasse)
         tmp = echantillon - ones(n,1)*mClasse(i,:);
	 d(:,i) = sum(tmp.^2,2);
     end

     % Affectation des individus a une classe
     [V,classe] = min(d,[],2);

     % Calcul des moyennes de chaque classe
     for i=1:length(mClasse)
         mClasse(i,:) = mean(echantillon(find(classe==i),:));
     end
    
     % Sauvegarde des moyennes successives de chaque classe
     mClasse1 = [ mClasse1 ; mClasse(1,:)];
     mClasse2 = [ mClasse2 ; mClasse(2,:)];
     mClasse3 = [ mClasse3 ; mClasse(3,:)];
     mClasse4 = [ mClasse4 ; mClasse(4,:)];
     mClasse5 = [ mClasse5 ; mClasse(5,:)];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Affichage final de l'echantillon
% Classe et moyenne

figure;

%%%%%%%%%%
% Classe 1
plot(echantillon(find(classe==1),1),echantillon(find(classe==1),2),'+');hold on;
plot(mClasse1(:,1),mClasse1(:,2),'d');hold on;

%%%%%%%%%%
% Classe 2
plot(echantillon(find(classe==2),1),echantillon(find(classe==2),2),'+g');hold on;
plot(mClasse2(:,1),mClasse2(:,2),'dg');hold on;

%%%%%%%%%%
% Classe 3
plot(echantillon(find(classe==3),1),echantillon(find(classe==3),2),'+r');hold on;
plot(mClasse3(:,1),mClasse3(:,2),'dr');hold on;

%%%%%%%%%%
% Classe 4
plot(echantillon(find(classe==4),1),echantillon(find(classe==4),2),'+k');hold on;
plot(mClasse4(:,1),mClasse4(:,2),'dk');

%%%%%%%%%%
% Classe 5
plot(echantillon(find(classe==5),1),echantillon(find(classe==5),2),'+y');hold on;
plot(mClasse5(:,1),mClasse5(:,2),'dy');

hold off;
